
;CodeVisionAVR C Compiler V3.30 Evaluation
;(C) Copyright 1998-2017 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega328P
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 512 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Mode 2
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega328P
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x08FF
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD2M
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _confirm=R3
	.DEF _confirm_msb=R4
	.DEF _selection=R5
	.DEF _selection_msb=R6
	.DEF _counter1=R7
	.DEF _counter1_msb=R8
	.DEF _counter2=R9
	.DEF _counter2_msb=R10
	.DEF _counter3=R11
	.DEF _counter3_msb=R12
	.DEF _counter4=R13
	.DEF _counter4_msb=R14

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0

_0x2E3:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x0

__GLOBAL_INI_TBL:
	.DW  0x0C
	.DW  0x03
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0x00

	.DSEG
	.ORG 0x300

	.CSEG
;/*******************************************************
;This program was created by the CodeWizardAVR V3.30
;Automatic Program Generator
; Copyright 1998-2017 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : project2
;Version : 0.1
;Date    : 29. 04. 2017
;Author  : aljaxus
;Company : -||-
;Comments:
;
;
;Chip type               : ATmega328P
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*******************************************************/
;
;#include <io.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;//DEFINE LED
;#define  ledr1 PORTC.2
;#define  ledy1 PORTC.3
;#define  ledg1 PORTC.4
;#define  ledr2 PORTD.4
;#define  ledy2 PORTD.3
;#define  ledg2 PORTD.2
;#define  ledr3 PORTB.1
;#define  ledy3 PORTB.2
;#define  ledg3 PORTB.3
;#define  ledr4 PORTD.5
;#define  ledy4 PORTD.6
;#define  ledg4 PORTD.7
;//DEFINE BUTTONS
;#define  button5 PINC.0
;#define  button1 PINC.5
;#define  button2 PINC.1
;#define  button3 PINB.0
;#define  button4 PINB.4
;int confirm=0;
;int selection;
;int counter1=0;
;int counter2=0;
;int counter3=0;
;int counter4=0;
;int counter5=0;
;int counter6=0;
;int pass1=0;
;int pass2=0;
;int pass3=0;
;int section2done=0;
;
;// Declare your global variables here
;
;
;// Timer1 overflow interrupt service routine
;interrupt [TIM1_OVF] void timer1_ovf_isr(void){
; 0000 003D interrupt [14] void timer1_ovf_isr(void){

	.CSEG
_timer1_ovf_isr:
; .FSTART _timer1_ovf_isr
	ST   -Y,R30
; 0000 003E 
; 0000 003F TCNT1H=0xFF;
	LDI  R30,LOW(255)
	RCALL SUBOPT_0x0
; 0000 0040 TCNT1L=0x00;
; 0000 0041 }
	LD   R30,Y+
	RETI
; .FEND
;
;void main(void)
; 0000 0044 {
_main:
; .FSTART _main
; 0000 0045 // Declare your local variables here
; 0000 0046 
; 0000 0047 // Crystal Oscillator division factor: 1
; 0000 0048 #pragma optsize-
; 0000 0049 CLKPR=(1<<CLKPCE);
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 004A CLKPR=(0<<CLKPCE) | (0<<CLKPS3) | (0<<CLKPS2) | (0<<CLKPS1) | (0<<CLKPS0);
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 004B #ifdef _OPTIMIZE_SIZE_
; 0000 004C #pragma optsize+
; 0000 004D #endif
; 0000 004E 
; 0000 004F // Input/Output Ports initialization
; 0000 0050 // Port B initialization
; 0000 0051 // Function: Bit7=In Bit6=In Bit5=Out Bit4=In Bit3=Out Bit2=Out Bit1=Out Bit0=In
; 0000 0052 DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (0<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (0<<DDB0);
	LDI  R30,LOW(46)
	OUT  0x4,R30
; 0000 0053 // State: Bit7=T Bit6=T Bit5=0 Bit4=P Bit3=0 Bit2=0 Bit1=0 Bit0=P
; 0000 0054 PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (1<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (1<<PORTB0);
	LDI  R30,LOW(17)
	OUT  0x5,R30
; 0000 0055 
; 0000 0056 // Port C initialization
; 0000 0057 // Function: Bit6=In Bit5=In Bit4=Out Bit3=Out Bit2=Out Bit1=In Bit0=In
; 0000 0058 DDRC=(0<<DDC6) | (0<<DDC5) | (1<<DDC4) | (1<<DDC3) | (1<<DDC2) | (0<<DDC1) | (0<<DDC0);
	LDI  R30,LOW(28)
	OUT  0x7,R30
; 0000 0059 // State: Bit6=T Bit5=P Bit4=0 Bit3=0 Bit2=0 Bit1=P Bit0=P
; 0000 005A PORTC=(0<<PORTC6) | (1<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (1<<PORTC1) | (1<<PORTC0);
	LDI  R30,LOW(35)
	OUT  0x8,R30
; 0000 005B 
; 0000 005C // Port D initialization
; 0000 005D // Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=In Bit0=In
; 0000 005E DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (1<<DDD3) | (1<<DDD2) | (0<<DDD1) | (0<<DDD0);
	LDI  R30,LOW(252)
	OUT  0xA,R30
; 0000 005F // State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=T Bit0=T
; 0000 0060 PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 0061 
; 0000 0062 // Timer/Counter 0 initialization
; 0000 0063 // Clock source: System Clock
; 0000 0064 // Clock value: Timer 0 Stopped
; 0000 0065 // Mode: Normal top=0xFF
; 0000 0066 // OC0A output: Disconnected
; 0000 0067 // OC0B output: Disconnected
; 0000 0068 TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (0<<WGM01) | (0<<WGM00);
	OUT  0x24,R30
; 0000 0069 TCCR0B=(0<<WGM02) | (0<<CS02) | (0<<CS01) | (0<<CS00);
	OUT  0x25,R30
; 0000 006A TCNT0=0x00;
	OUT  0x26,R30
; 0000 006B OCR0A=0x00;
	OUT  0x27,R30
; 0000 006C OCR0B=0x00;
	OUT  0x28,R30
; 0000 006D 
; 0000 006E // Timer/Counter 1 initialization
; 0000 006F // Clock source: System Clock
; 0000 0070 // Clock value: 15,625 kHz
; 0000 0071 // Mode: Normal top=0xFFFF
; 0000 0072 // OC1A output: Disconnected
; 0000 0073 // OC1B output: Disconnected
; 0000 0074 // Noise Canceler: Off
; 0000 0075 // Input Capture on Falling Edge
; 0000 0076 // Timer Period: 4,1943 s
; 0000 0077 // Timer1 Overflow Interrupt: On
; 0000 0078 // Input Capture Interrupt: Off
; 0000 0079 // Compare A Match Interrupt: Off
; 0000 007A // Compare B Match Interrupt: Off
; 0000 007B TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
	STS  128,R30
; 0000 007C TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (1<<CS12) | (0<<CS11) | (1<<CS10);
	LDI  R30,LOW(5)
	STS  129,R30
; 0000 007D TCNT1H=0x00;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x0
; 0000 007E TCNT1L=0x00;
; 0000 007F ICR1H=0x00;
	LDI  R30,LOW(0)
	STS  135,R30
; 0000 0080 ICR1L=0x00;
	STS  134,R30
; 0000 0081 OCR1AH=0x00;
	STS  137,R30
; 0000 0082 OCR1AL=0x00;
	STS  136,R30
; 0000 0083 OCR1BH=0x00;
	STS  139,R30
; 0000 0084 OCR1BL=0x00;
	STS  138,R30
; 0000 0085 
; 0000 0086 // Timer/Counter 2 initialization
; 0000 0087 // Clock source: System Clock
; 0000 0088 // Clock value: Timer2 Stopped
; 0000 0089 // Mode: Normal top=0xFF
; 0000 008A // OC2A output: Disconnected
; 0000 008B // OC2B output: Disconnected
; 0000 008C ASSR=(0<<EXCLK) | (0<<AS2);
	STS  182,R30
; 0000 008D TCCR2A=(0<<COM2A1) | (0<<COM2A0) | (0<<COM2B1) | (0<<COM2B0) | (0<<WGM21) | (0<<WGM20);
	STS  176,R30
; 0000 008E TCCR2B=(0<<WGM22) | (0<<CS22) | (0<<CS21) | (0<<CS20);
	STS  177,R30
; 0000 008F TCNT2=0x00;
	STS  178,R30
; 0000 0090 OCR2A=0x00;
	STS  179,R30
; 0000 0091 OCR2B=0x00;
	STS  180,R30
; 0000 0092 
; 0000 0093 // Timer/Counter 0 Interrupt(s) initialization
; 0000 0094 TIMSK0=(0<<OCIE0B) | (0<<OCIE0A) | (0<<TOIE0);
	STS  110,R30
; 0000 0095 
; 0000 0096 // Timer/Counter 1 Interrupt(s) initialization
; 0000 0097 TIMSK1=(0<<ICIE1) | (0<<OCIE1B) | (0<<OCIE1A) | (1<<TOIE1);
	LDI  R30,LOW(1)
	STS  111,R30
; 0000 0098 
; 0000 0099 // Timer/Counter 2 Interrupt(s) initialization
; 0000 009A TIMSK2=(0<<OCIE2B) | (0<<OCIE2A) | (0<<TOIE2);
	LDI  R30,LOW(0)
	STS  112,R30
; 0000 009B 
; 0000 009C // External Interrupt(s) initialization
; 0000 009D // INT0: Off
; 0000 009E // INT1: Off
; 0000 009F // Interrupt on any change on pins PCINT0-7: Off
; 0000 00A0 // Interrupt on any change on pins PCINT8-14: Off
; 0000 00A1 // Interrupt on any change on pins PCINT16-23: Off
; 0000 00A2 EICRA=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
	STS  105,R30
; 0000 00A3 EIMSK=(0<<INT1) | (0<<INT0);
	OUT  0x1D,R30
; 0000 00A4 PCICR=(0<<PCIE2) | (0<<PCIE1) | (0<<PCIE0);
	STS  104,R30
; 0000 00A5 
; 0000 00A6 // USART initialization
; 0000 00A7 // USART disabled
; 0000 00A8 UCSR0B=(0<<RXCIE0) | (0<<TXCIE0) | (0<<UDRIE0) | (0<<RXEN0) | (0<<TXEN0) | (0<<UCSZ02) | (0<<RXB80) | (0<<TXB80);
	STS  193,R30
; 0000 00A9 
; 0000 00AA // Analog Comparator initialization
; 0000 00AB // Analog Comparator: Off
; 0000 00AC // The Analog Comparator's positive input is
; 0000 00AD // connected to the AIN0 pin
; 0000 00AE // The Analog Comparator's negative input is
; 0000 00AF // connected to the AIN1 pin
; 0000 00B0 ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 00B1 ADCSRB=(0<<ACME);
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 00B2 // Digital input buffer on AIN0: On
; 0000 00B3 // Digital input buffer on AIN1: On
; 0000 00B4 DIDR1=(0<<AIN0D) | (0<<AIN1D);
	STS  127,R30
; 0000 00B5 
; 0000 00B6 // ADC initialization
; 0000 00B7 // ADC disabled
; 0000 00B8 ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADATE) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
	STS  122,R30
; 0000 00B9 
; 0000 00BA // SPI initialization
; 0000 00BB // SPI disabled
; 0000 00BC SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
	OUT  0x2C,R30
; 0000 00BD 
; 0000 00BE // TWI initialization
; 0000 00BF // TWI disabled
; 0000 00C0 TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
	STS  188,R30
; 0000 00C1 
; 0000 00C2 // Globally enable interrupts
; 0000 00C3 #asm("sei")
	SEI
; 0000 00C4 
; 0000 00C5 while (1)
_0x3:
; 0000 00C6       {
; 0000 00C7           //UDWLOCSE KEJ CS JMT
; 0000 00C8           if (selection == 1){
	RCALL SUBOPT_0x1
	BRNE _0x6
; 0000 00C9             ledr4 = 0;
	RCALL SUBOPT_0x2
; 0000 00CA             ledy4 = 0;
; 0000 00CB             ledg4 = 0;
; 0000 00CC             ledy2 = 0;
; 0000 00CD             ledg2 = 1;
	SBI  0xB,2
; 0000 00CE             ledr2 = 0;
	CBI  0xB,4
; 0000 00CF           }
; 0000 00D0           if (selection == 2){
_0x6:
	RCALL SUBOPT_0x3
	BRNE _0x13
; 0000 00D1             ledr4 = 0;
	CBI  0xB,5
; 0000 00D2             ledy4 = 0;
	CBI  0xB,6
; 0000 00D3             ledg4 = 0;
	CBI  0xB,7
; 0000 00D4             ledy2 = 1;
	SBI  0xB,3
; 0000 00D5             ledg2 = 0;
	CBI  0xB,2
; 0000 00D6             ledr2 = 0;
	CBI  0xB,4
; 0000 00D7           }
; 0000 00D8           if (selection == 3){
_0x13:
	RCALL SUBOPT_0x4
	BRNE _0x20
; 0000 00D9             ledr4 = 0;
	RCALL SUBOPT_0x2
; 0000 00DA             ledy4 = 0;
; 0000 00DB             ledg4 = 0;
; 0000 00DC             ledy2 = 0;
; 0000 00DD             ledg2 = 0;
	CBI  0xB,2
; 0000 00DE             ledr2 = 1;
	SBI  0xB,4
; 0000 00DF           }
; 0000 00E0           if (selection == 4){
_0x20:
	RCALL SUBOPT_0x5
	BRNE _0x2D
; 0000 00E1             ledr4 = 1;
	SBI  0xB,5
; 0000 00E2             ledy4 = 0;
	CBI  0xB,6
; 0000 00E3             ledg4 = 0;
	RCALL SUBOPT_0x6
; 0000 00E4             ledy2 = 0;
; 0000 00E5             ledg2 = 0;
; 0000 00E6             ledr2 = 0;
; 0000 00E7           }
; 0000 00E8           if (selection == 5){
_0x2D:
	RCALL SUBOPT_0x7
	BRNE _0x3A
; 0000 00E9             ledr4 = 0;
	CBI  0xB,5
; 0000 00EA             ledy4 = 1;
	SBI  0xB,6
; 0000 00EB             ledg4 = 0;
	RCALL SUBOPT_0x6
; 0000 00EC             ledy2 = 0;
; 0000 00ED             ledg2 = 0;
; 0000 00EE             ledr2 = 0;
; 0000 00EF           }
; 0000 00F0           if (selection == 6){
_0x3A:
	RCALL SUBOPT_0x8
	BRNE _0x47
; 0000 00F1             ledr4 = 0;
	CBI  0xB,5
; 0000 00F2             ledy4 = 0;
	CBI  0xB,6
; 0000 00F3             ledg4 = 1;
	SBI  0xB,7
; 0000 00F4             ledy2 = 0;
	CBI  0xB,3
; 0000 00F5             ledg2 = 0;
	CBI  0xB,2
; 0000 00F6             ledr2 = 0;
	CBI  0xB,4
; 0000 00F7           }
; 0000 00F8           if (selection == 7){
_0x47:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R5
	CPC  R31,R6
	BRNE _0x54
; 0000 00F9            selection = 1;
	RCALL SUBOPT_0x9
; 0000 00FA           }
; 0000 00FB           if (selection == 0){
_0x54:
	MOV  R0,R5
	OR   R0,R6
	BRNE _0x55
; 0000 00FC            selection = 6;
	RCALL SUBOPT_0xA
; 0000 00FD           }
; 0000 00FE           if (button3 == 0){
_0x55:
	SBIC 0x3,0
	RJMP _0x56
; 0000 00FF            selection++;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 5,6,30,31
; 0000 0100            delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 0101           }
; 0000 0102           if (button2 == 0){
_0x56:
	SBIC 0x6,1
	RJMP _0x57
; 0000 0103            selection--;
	__GETW1R 5,6
	SBIW R30,1
	__PUTW1R 5,6
; 0000 0104            delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 0105           }
; 0000 0106           if (button5 == 0){
_0x57:
	SBIC 0x6,0
	RJMP _0x58
; 0000 0107            confirm = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 3,4
; 0000 0108           }
; 0000 0109           //KU JE POTRJENO KEJ SI IZBROW
; 0000 010A           if (confirm == 1){
_0x58:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R3
	CPC  R31,R4
	BREQ PC+2
	RJMP _0x59
; 0000 010B                //TI CS JMT PRVO OPCIJO
; 0000 010C                if (selection == 1){
	RCALL SUBOPT_0x1
	BREQ PC+2
	RJMP _0x5A
; 0000 010D                   for (counter1=0; counter1 < 10;counter1++) {
	CLR  R7
	CLR  R8
_0x5C:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R7,R30
	CPC  R8,R31
	BRGE _0x5D
; 0000 010E                   ledg1=1;
	RCALL SUBOPT_0xB
; 0000 010F                   ledg2=1;
; 0000 0110                   ledg3=1;
; 0000 0111                   ledg4=1;
; 0000 0112                   delay_ms(50)   ;
; 0000 0113                   ledg1=0;
; 0000 0114                   ledg2=0;
; 0000 0115                   ledg3=0;
; 0000 0116                   ledg4=0;
; 0000 0117 
; 0000 0118                   ledy1=1;
	RCALL SUBOPT_0xC
; 0000 0119                   ledy2=1;
; 0000 011A                   ledy3=1;
; 0000 011B                   ledy4=1;
; 0000 011C                   delay_ms(50)   ;
; 0000 011D                   ledy1=0;
; 0000 011E                   ledy2=0;
; 0000 011F                   ledy3=0;
; 0000 0120                   ledy4=0;
; 0000 0121 
; 0000 0122 
; 0000 0123                   ledr1=1;
	RCALL SUBOPT_0xD
; 0000 0124                   ledr2=1;
; 0000 0125                   ledr3=1;
; 0000 0126                   ledr4=1;
; 0000 0127                   delay_ms(50)   ;
; 0000 0128                   ledr1=0;
; 0000 0129                   ledr2=0;
; 0000 012A                   ledr3=0;
; 0000 012B                   ledr4=0;
; 0000 012C 
; 0000 012D                   ledr1=1;
	RCALL SUBOPT_0xD
; 0000 012E                   ledr2=1;
; 0000 012F                   ledr3=1;
; 0000 0130                   ledr4=1;
; 0000 0131                   delay_ms(50)   ;
; 0000 0132                   ledr1=0;
; 0000 0133                   ledr2=0;
; 0000 0134                   ledr3=0;
; 0000 0135                   ledr4=0;
; 0000 0136 
; 0000 0137                   ledy1=1;
	RCALL SUBOPT_0xC
; 0000 0138                   ledy2=1;
; 0000 0139                   ledy3=1;
; 0000 013A                   ledy4=1;
; 0000 013B                   delay_ms(50)   ;
; 0000 013C                   ledy1=0;
; 0000 013D                   ledy2=0;
; 0000 013E                   ledy3=0;
; 0000 013F                   ledy4=0;
; 0000 0140 
; 0000 0141                   ledg1=1;
	RCALL SUBOPT_0xB
; 0000 0142                   ledg2=1;
; 0000 0143                   ledg3=1;
; 0000 0144                   ledg4=1;
; 0000 0145                   delay_ms(50)   ;
; 0000 0146                   ledg1=0;
; 0000 0147                   ledg2=0;
; 0000 0148                   ledg3=0;
; 0000 0149                   ledg4=0;
; 0000 014A                   };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 7,8,30,31
	RJMP _0x5C
_0x5D:
; 0000 014B                   counter1 = 0;
	CLR  R7
	CLR  R8
; 0000 014C 
; 0000 014D                   ledg1=1;
	RCALL SUBOPT_0xE
; 0000 014E                   delay_ms(100);
; 0000 014F                   ledg1=0;
; 0000 0150                   ledy1=1;
; 0000 0151                   delay_ms(100);
; 0000 0152                   ledy1=0;
; 0000 0153                   ledr1=1;
; 0000 0154                   delay_ms(100);
; 0000 0155                   ledr1=0;
; 0000 0156 
; 0000 0157                   ledg2=1;
	RCALL SUBOPT_0xF
; 0000 0158                   delay_ms(100);
; 0000 0159                   ledg2=0;
; 0000 015A                   ledy2=1;
; 0000 015B                   delay_ms(100);
; 0000 015C                   ledy2=0;
; 0000 015D                   ledr2=1;
; 0000 015E                   delay_ms(100);
; 0000 015F                   ledr2=0;
; 0000 0160 
; 0000 0161                   ledg3=1;
	RCALL SUBOPT_0x10
; 0000 0162                   delay_ms(100);
; 0000 0163                   ledg3=0;
; 0000 0164                   ledy3=1;
; 0000 0165                   delay_ms(100);
; 0000 0166                   ledy3=0;
; 0000 0167                   ledr3=1;
; 0000 0168                   delay_ms(100);
; 0000 0169                   ledr3=0;
; 0000 016A 
; 0000 016B                   ledg4=1;
; 0000 016C                   delay_ms(100);
; 0000 016D                   ledg4=0;
; 0000 016E                   ledy4=1;
; 0000 016F                   delay_ms(100);
; 0000 0170                   ledy4=0;
; 0000 0171                   ledr4=1;
; 0000 0172                   delay_ms(100);
; 0000 0173                   ledr4=0;
; 0000 0174 
; 0000 0175                    ledg1=1;
	RCALL SUBOPT_0xE
; 0000 0176                   delay_ms(100);
; 0000 0177                   ledg1=0;
; 0000 0178                   ledy1=1;
; 0000 0179                   delay_ms(100);
; 0000 017A                   ledy1=0;
; 0000 017B                   ledr1=1;
; 0000 017C                   delay_ms(100);
; 0000 017D                   ledr1=0;
; 0000 017E 
; 0000 017F                   ledg3=1;
	RCALL SUBOPT_0x10
; 0000 0180                   delay_ms(100);
; 0000 0181                   ledg3=0;
; 0000 0182                   ledy3=1;
; 0000 0183                   delay_ms(100);
; 0000 0184                   ledy3=0;
; 0000 0185                   ledr3=1;
; 0000 0186                   delay_ms(100);
; 0000 0187                   ledr3=0;
; 0000 0188 
; 0000 0189                   ledg4=1;
; 0000 018A                   delay_ms(100);
; 0000 018B                   ledg4=0;
; 0000 018C                   ledy4=1;
; 0000 018D                   delay_ms(100);
; 0000 018E                   ledy4=0;
; 0000 018F                   ledr4=1;
; 0000 0190                   delay_ms(100);
; 0000 0191                   ledr4=0;
; 0000 0192 
; 0000 0193                   ledg2=1;
	RCALL SUBOPT_0xF
; 0000 0194                   delay_ms(100);
; 0000 0195                   ledg2=0;
; 0000 0196                   ledy2=1;
; 0000 0197                   delay_ms(100);
; 0000 0198                   ledy2=0;
; 0000 0199                   ledr2=1;
; 0000 019A                   delay_ms(100);
; 0000 019B                   ledr2=0;
; 0000 019C 
; 0000 019D                   ledg1=1;
	SBI  0x8,4
; 0000 019E                   ledy1=1;
	SBI  0x8,3
; 0000 019F                   ledr1=1;
	SBI  0x8,2
; 0000 01A0                   delay_ms(50)   ;
	RCALL SUBOPT_0x11
; 0000 01A1                   ledr1=0;
; 0000 01A2                   ledy1=0;
; 0000 01A3                   ledr1=0;
	CBI  0x8,2
; 0000 01A4 
; 0000 01A5                   ledr1=1;
	SBI  0x8,2
; 0000 01A6                   ledy1=1;
	SBI  0x8,3
; 0000 01A7                   ledg1=1;
	SBI  0x8,4
; 0000 01A8                   delay_ms(50)   ;
	RCALL SUBOPT_0x11
; 0000 01A9                   ledr1=0;
; 0000 01AA                   ledy1=0;
; 0000 01AB                   ledg1=0;
	CBI  0x8,4
; 0000 01AC 
; 0000 01AD                    ledg3=1;
	SBI  0x5,3
; 0000 01AE                   ledy3=1;
	SBI  0x5,2
; 0000 01AF                   ledr3=1;
	RCALL SUBOPT_0x12
; 0000 01B0                   delay_ms(50)   ;
; 0000 01B1                   ledr3=0;
	CBI  0x5,1
; 0000 01B2                   ledy3=0;
	CBI  0x5,2
; 0000 01B3                   ledr3=0;
	CBI  0x5,1
; 0000 01B4 
; 0000 01B5                   ledr3=1;
	SBI  0x5,1
; 0000 01B6                   ledy3=1;
	SBI  0x5,2
; 0000 01B7                   ledg3=1;
	RCALL SUBOPT_0x13
; 0000 01B8                   delay_ms(50)   ;
; 0000 01B9                   ledr3=0;
	CBI  0x5,1
; 0000 01BA                   ledy3=0;
	CBI  0x5,2
; 0000 01BB                   ledg3=0;
	CBI  0x5,3
; 0000 01BC 
; 0000 01BD                     ledg2=1;
	RCALL SUBOPT_0xF
; 0000 01BE                   delay_ms(100);
; 0000 01BF                   ledg2=0;
; 0000 01C0                   ledy2=1;
; 0000 01C1                   delay_ms(100);
; 0000 01C2                   ledy2=0;
; 0000 01C3                   ledr2=1;
; 0000 01C4                   delay_ms(100);
; 0000 01C5                   ledr2=0;
; 0000 01C6 
; 0000 01C7                    ledg4=1;
	RCALL SUBOPT_0x14
; 0000 01C8                   delay_ms(100);
; 0000 01C9                   ledg4=0;
	CBI  0xB,7
; 0000 01CA                   ledy4=1;
	SBI  0xB,6
; 0000 01CB                   delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 01CC                   ledy4=0;
	CBI  0xB,6
; 0000 01CD                   ledr4=1;
	SBI  0xB,5
; 0000 01CE                   delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 01CF                   ledr4=0;
	CBI  0xB,5
; 0000 01D0 
; 0000 01D1                   ledg2=1;
	SBI  0xB,2
; 0000 01D2                   ledy2=1;
	SBI  0xB,3
; 0000 01D3                   ledr2=1;
	SBI  0xB,4
; 0000 01D4                   delay_ms(50)   ;
	RCALL SUBOPT_0x15
; 0000 01D5                   ledr2=0;
; 0000 01D6                   ledy2=0;
; 0000 01D7                   ledr2=0;
	CBI  0xB,4
; 0000 01D8 
; 0000 01D9                   ledr2=1;
	SBI  0xB,4
; 0000 01DA                   ledy2=1;
	SBI  0xB,3
; 0000 01DB                   ledg2=1;
	SBI  0xB,2
; 0000 01DC                   delay_ms(50)   ;
	RCALL SUBOPT_0x15
; 0000 01DD                   ledr2=0;
; 0000 01DE                   ledy2=0;
; 0000 01DF                   ledg2=0;
	CBI  0xB,2
; 0000 01E0 
; 0000 01E1                    ledg4=1;
	SBI  0xB,7
; 0000 01E2                   ledy4=1;
	SBI  0xB,6
; 0000 01E3                   ledr4=1;
	RCALL SUBOPT_0x16
; 0000 01E4                   delay_ms(50)   ;
; 0000 01E5                   ledr4=0;
	CBI  0xB,5
; 0000 01E6                   ledy4=0;
	CBI  0xB,6
; 0000 01E7                   ledr4=0;
	CBI  0xB,5
; 0000 01E8 
; 0000 01E9                   ledr4=1;
	SBI  0xB,5
; 0000 01EA                   ledy4=1;
	SBI  0xB,6
; 0000 01EB                   ledg4=1;
	RCALL SUBOPT_0x17
; 0000 01EC                   delay_ms(50)   ;
; 0000 01ED                   ledr4=0;
	CBI  0xB,5
; 0000 01EE                   ledy4=0;
	CBI  0xB,6
; 0000 01EF                   ledg4=0;
	CBI  0xB,7
; 0000 01F0 
; 0000 01F1                   ledg3=1;
	RCALL SUBOPT_0x18
; 0000 01F2                   delay_ms(100);
; 0000 01F3                   ledg3=0;
	CBI  0x5,3
; 0000 01F4                   ledy3=1;
	SBI  0x5,2
; 0000 01F5                   delay_ms(100);
	LDI  R26,LOW(100)
	RCALL SUBOPT_0x19
; 0000 01F6                   ledy3=0;
; 0000 01F7                   ledr3=1;
; 0000 01F8                   delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 01F9                   ledr3=0;
	CBI  0x5,1
; 0000 01FA 
; 0000 01FB                   ledg1=1;
	RCALL SUBOPT_0xE
; 0000 01FC                   delay_ms(100);
; 0000 01FD                   ledg1=0;
; 0000 01FE                   ledy1=1;
; 0000 01FF                   delay_ms(100);
; 0000 0200                   ledy1=0;
; 0000 0201                   ledr1=1;
; 0000 0202                   delay_ms(100);
; 0000 0203                   ledr1=0;
; 0000 0204 
; 0000 0205                   selection = 1;
	RCALL SUBOPT_0x9
; 0000 0206                }
; 0000 0207                //TI CS JMT DRUGO OPCIJO
; 0000 0208                if (selection == 2){
_0x5A:
	RCALL SUBOPT_0x3
	BREQ PC+2
	RJMP _0x1AE
; 0000 0209                   //CE JE KODA PRAVA
; 0000 020A                   while (section2done == 0){
_0x1AF:
	LDS  R30,_section2done
	LDS  R31,_section2done+1
	SBIW R30,0
	BREQ PC+2
	RJMP _0x1B1
; 0000 020B                         ledy1 = 1;
	RCALL SUBOPT_0x1A
; 0000 020C                         ledy2 = 1;
; 0000 020D                         ledy3 = 1;
; 0000 020E                         ledy4 = 1;
; 0000 020F                         delay_ms(500);
; 0000 0210                         ledy1 = 0;
; 0000 0211                         ledy2 = 0;
; 0000 0212                         ledy3 = 0;
; 0000 0213                         ledy4 = 0;
; 0000 0214                         delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 0215                         ledr1 = 1;
	RCALL SUBOPT_0x1B
; 0000 0216                         ledr2 = 1;
; 0000 0217                         ledr3 = 1;
; 0000 0218                         ledr4 = 1;
; 0000 0219                         delay_ms(500);
; 0000 021A                         ledr1 = 0;
; 0000 021B                         ledr2 = 0;
; 0000 021C                         ledr3 = 0;
; 0000 021D                         ledr4 = 0;
; 0000 021E                         delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 021F                       if(button1 == 0){
	SBIC 0x6,5
	RJMP _0x1D2
; 0000 0220                         ledr1 = 1;
	RCALL SUBOPT_0x1B
; 0000 0221                         ledr2 = 1;
; 0000 0222                         ledr3 = 1;
; 0000 0223                         ledr4 = 1;
; 0000 0224                         delay_ms(500);
; 0000 0225                         ledr1 = 0;
; 0000 0226                         ledr2 = 0;
; 0000 0227                         ledr3 = 0;
; 0000 0228                         ledr4 = 0;
; 0000 0229                         pass1 = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _pass1,R30
	STS  _pass1+1,R31
; 0000 022A                       }
; 0000 022B                       if(button2 == 0){
_0x1D2:
	SBIC 0x6,1
	RJMP _0x1E3
; 0000 022C                         ledr1 = 1;
	RCALL SUBOPT_0x1B
; 0000 022D                         ledr2 = 1;
; 0000 022E                         ledr3 = 1;
; 0000 022F                         ledr4 = 1;
; 0000 0230                         delay_ms(500);
; 0000 0231                         ledr1 = 0;
; 0000 0232                         ledr2 = 0;
; 0000 0233                         ledr3 = 0;
; 0000 0234                         ledr4 = 0;
; 0000 0235                         pass2 = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _pass2,R30
	STS  _pass2+1,R31
; 0000 0236                       }
; 0000 0237                       if(button5 == 0){
_0x1E3:
	SBIC 0x6,0
	RJMP _0x1F4
; 0000 0238                         ledr1 = 1;
	RCALL SUBOPT_0x1B
; 0000 0239                         ledr2 = 1;
; 0000 023A                         ledr3 = 1;
; 0000 023B                         ledr4 = 1;
; 0000 023C                         delay_ms(500);
; 0000 023D                         ledr1 = 0;
; 0000 023E                         ledr2 = 0;
; 0000 023F                         ledr3 = 0;
; 0000 0240                         ledr4 = 0;
; 0000 0241                         pass3 = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _pass3,R30
	STS  _pass3+1,R31
; 0000 0242                       }
; 0000 0243                       //E JE KONA NAPANA
; 0000 0244                       if(button3 == 0){
_0x1F4:
	SBIS 0x3,0
; 0000 0245                         ledr1 = 1;
	RCALL SUBOPT_0x1C
; 0000 0246                         ledr2 = 1;
; 0000 0247                         ledr3 = 1;
; 0000 0248                         ledr4 = 1;
; 0000 0249                         pass1 = 0;
; 0000 024A                         pass2 = 0;
; 0000 024B                         pass3 = 0;
; 0000 024C                         delay_ms(500);
; 0000 024D                         ledr1 = 0;
; 0000 024E                         ledr2 = 0;
; 0000 024F                         ledr3 = 0;
; 0000 0250                         ledr4 = 0;
; 0000 0251                       }
; 0000 0252                       if(button4 == 0){
	SBIS 0x3,4
; 0000 0253                         ledr1 = 1;
	RCALL SUBOPT_0x1C
; 0000 0254                         ledr2 = 1;
; 0000 0255                         ledr3 = 1;
; 0000 0256                         ledr4 = 1;
; 0000 0257                         pass1 = 0;
; 0000 0258                         pass2 = 0;
; 0000 0259                         pass3 = 0;
; 0000 025A                         delay_ms(500);
; 0000 025B                         ledr1 = 0;
; 0000 025C                         ledr2 = 0;
; 0000 025D                         ledr3 = 0;
; 0000 025E                         ledr4 = 0;
; 0000 025F                       }
; 0000 0260                       //CE SO USE STVARI PRAV
; 0000 0261                       if (pass1&pass2&pass3==1){
	LDS  R30,_pass2
	LDS  R31,_pass2+1
	LDS  R26,_pass1
	LDS  R27,_pass1+1
	AND  R30,R26
	AND  R31,R27
	MOVW R0,R30
	LDS  R26,_pass3
	LDS  R27,_pass3+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL __EQW12
	LDI  R31,0
	AND  R30,R0
	AND  R31,R1
	SBIW R30,0
	BREQ _0x227
; 0000 0262                         ledg1 = 1;
	SBI  0x8,4
; 0000 0263                         ledg2 = 1;
	SBI  0xB,2
; 0000 0264                         ledg3 = 1;
	SBI  0x5,3
; 0000 0265                         ledg4 = 1;
	SBI  0xB,7
; 0000 0266                         delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
; 0000 0267                         ledg1 = 0;
	CBI  0x8,4
; 0000 0268                         ledg2 = 0;
	CBI  0xB,2
; 0000 0269                         ledg3 = 0;
	CBI  0x5,3
; 0000 026A                         ledg4 = 0;
	CBI  0xB,7
; 0000 026B                         ledy1 = 1;
	RCALL SUBOPT_0x1A
; 0000 026C                         ledy2 = 1;
; 0000 026D                         ledy3 = 1;
; 0000 026E                         ledy4 = 1;
; 0000 026F                         delay_ms(500);
; 0000 0270                         ledy1 = 0;
; 0000 0271                         ledy2 = 0;
; 0000 0272                         ledy3 = 0;
; 0000 0273                         ledy4 = 0;
; 0000 0274                         ledr1 = 1;
	RCALL SUBOPT_0x1B
; 0000 0275                         ledr2 = 1;
; 0000 0276                         ledr3 = 1;
; 0000 0277                         ledr4 = 1;
; 0000 0278                         delay_ms(500);
; 0000 0279                         ledr1 = 0;
; 0000 027A                         ledr2 = 0;
; 0000 027B                         ledr3 = 0;
; 0000 027C                         ledr4 = 0;
; 0000 027D                         delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 027E                         pass1 = 0;
	LDI  R30,LOW(0)
	STS  _pass1,R30
	STS  _pass1+1,R30
; 0000 027F                         pass2 = 0;
	STS  _pass2,R30
	STS  _pass2+1,R30
; 0000 0280                         pass3 = 0;
	STS  _pass3,R30
	STS  _pass3+1,R30
; 0000 0281                         section2done = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _section2done,R30
	STS  _section2done+1,R31
; 0000 0282                         delay_ms(250);
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0283                       }
; 0000 0284                   }
_0x227:
	RJMP _0x1AF
_0x1B1:
; 0000 0285                   section2done = 0;
	LDI  R30,LOW(0)
	STS  _section2done,R30
	STS  _section2done+1,R30
; 0000 0286                   selection = 2;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1R 5,6
; 0000 0287                }
; 0000 0288                //TI CS JMT TRETJO OPCIJO
; 0000 0289                if (selection == 3){
_0x1AE:
	RCALL SUBOPT_0x4
	BRNE _0x258
; 0000 028A                ledr2 = 0;
	CBI  0xB,4
; 0000 028B                   for (counter2=0; counter2 < 10;counter2++) {
	CLR  R9
	CLR  R10
_0x25C:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R9,R30
	CPC  R10,R31
	BRGE _0x25D
; 0000 028C                       for (counter3=0; counter3 < 10;counter3++) {
	CLR  R11
	CLR  R12
_0x25F:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R11,R30
	CPC  R12,R31
	BRGE _0x260
; 0000 028D                       ledr1 = 1;
	SBI  0x8,2
; 0000 028E                       ledr3 = 1;
	RCALL SUBOPT_0x12
; 0000 028F                       delay_ms(50);
; 0000 0290                       ledr1 = 0;
	CBI  0x8,2
; 0000 0291                       ledr3 = 0;
	CBI  0x5,1
; 0000 0292                       ledy1 = 1;
	SBI  0x8,3
; 0000 0293                       ledy3 = 1;
	SBI  0x5,2
; 0000 0294                       delay_ms(50);
	RCALL SUBOPT_0x1D
; 0000 0295                       ledy1 = 0;
; 0000 0296                       ledy3 = 0;
	CBI  0x5,2
; 0000 0297                       ledg1 = 1;
	SBI  0x8,4
; 0000 0298                       ledg3 = 1;
	RCALL SUBOPT_0x13
; 0000 0299                       delay_ms(50);
; 0000 029A                       ledg1 = 0;
	CBI  0x8,4
; 0000 029B                       ledg3 = 0;
	CBI  0x5,3
; 0000 029C                       }
	RCALL SUBOPT_0x1E
	RJMP _0x25F
_0x260:
; 0000 029D                       counter3 = 0;
	CLR  R11
	CLR  R12
; 0000 029E 
; 0000 029F                       ledr2 = 1;
	SBI  0xB,4
; 0000 02A0                       ledr4 = 1;
	RCALL SUBOPT_0x16
; 0000 02A1                       delay_ms(50);
; 0000 02A2                       ledr2 = 0;
	CBI  0xB,4
; 0000 02A3                       ledr4 = 0;
	CBI  0xB,5
; 0000 02A4                       ledy2 = 1;
	SBI  0xB,3
; 0000 02A5                       ledy4 = 1;
	SBI  0xB,6
; 0000 02A6                       delay_ms(50);
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02A7                       ledy2 = 0;
	CBI  0xB,3
; 0000 02A8                       ledy4 = 0;
	CBI  0xB,6
; 0000 02A9                       ledg2 = 1;
	SBI  0xB,2
; 0000 02AA                       ledg4 = 1;
	RCALL SUBOPT_0x17
; 0000 02AB                       delay_ms(50);
; 0000 02AC                       ledg2 = 0;
	CBI  0xB,2
; 0000 02AD                       ledg4 = 0;
	CBI  0xB,7
; 0000 02AE                   }
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 9,10,30,31
	RJMP _0x25C
_0x25D:
; 0000 02AF                   counter2 = 0;
	CLR  R9
	CLR  R10
; 0000 02B0                   selection = 3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1R 5,6
; 0000 02B1                }
; 0000 02B2                //TI CS JMT CETRTO OPCIJO
; 0000 02B3                if (selection == 4){
_0x258:
	RCALL SUBOPT_0x5
	BREQ PC+2
	RJMP _0x291
; 0000 02B4                ledr4 = 0;
	CBI  0xB,5
; 0000 02B5                   for (counter3=0; counter3 < 3;counter3++) {
	CLR  R11
	CLR  R12
_0x295:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R11,R30
	CPC  R12,R31
	BRGE _0x296
; 0000 02B6                     ledg3 = 1;
	RCALL SUBOPT_0x1F
; 0000 02B7                     delay_ms(250);
; 0000 02B8                     ledg3 = 0;
	CBI  0x5,3
; 0000 02B9                     ledy3 = 1;
	SBI  0x5,2
; 0000 02BA                     delay_ms(250);
	LDI  R26,LOW(250)
	RCALL SUBOPT_0x19
; 0000 02BB                     ledy3 = 0;
; 0000 02BC                     ledr3 = 1;
; 0000 02BD                     delay_ms(250);
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02BE                     ledr3 = 0;
	CBI  0x5,1
; 0000 02BF                     delay_ms(100);
	RCALL SUBOPT_0x20
; 0000 02C0                     ledr1 = 1;
; 0000 02C1                     ledr2 = 1;
	SBI  0xB,4
; 0000 02C2                     ledr4 = 1;
	RCALL SUBOPT_0x16
; 0000 02C3                     delay_ms(50);
; 0000 02C4                     ledr1 = 0;
	CBI  0x8,2
; 0000 02C5                     ledr2 = 0;
	CBI  0xB,4
; 0000 02C6                     ledr4 = 0;
	CBI  0xB,5
; 0000 02C7                     ledy1 = 1;
	SBI  0x8,3
; 0000 02C8                     ledy2 = 1;
	SBI  0xB,3
; 0000 02C9                     ledy4 = 1;
	SBI  0xB,6
; 0000 02CA                     delay_ms(50);
	RCALL SUBOPT_0x1D
; 0000 02CB                     ledy1 = 0;
; 0000 02CC                     ledy2 = 0;
	CBI  0xB,3
; 0000 02CD                     ledy4 = 0;
	CBI  0xB,6
; 0000 02CE                     ledg1 = 1;
	SBI  0x8,4
; 0000 02CF                     ledg2 = 1;
	SBI  0xB,2
; 0000 02D0                     ledg4 = 1;
	RCALL SUBOPT_0x17
; 0000 02D1                     delay_ms(50);
; 0000 02D2                     ledg1 = 0;
	RCALL SUBOPT_0x21
; 0000 02D3                     ledg2 = 0;
; 0000 02D4                     ledg4 = 0;
; 0000 02D5                     delay_ms(50);
; 0000 02D6                     for (counter4=0; counter4 < 4;counter4++) {
	CLR  R13
	CLR  R14
_0x2C8:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R13,R30
	CPC  R14,R31
	BRGE _0x2C9
; 0000 02D7                         ledg1 = 1;
	SBI  0x8,4
; 0000 02D8                         ledg2 = 1;
	SBI  0xB,2
; 0000 02D9                         ledg4 = 1;
	RCALL SUBOPT_0x17
; 0000 02DA                         delay_ms(50);
; 0000 02DB                         ledg1 = 0;
	RCALL SUBOPT_0x21
; 0000 02DC                         ledg2 = 0;
; 0000 02DD                         ledg4 = 0;
; 0000 02DE                         delay_ms(50);
; 0000 02DF                     }
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 13,14,30,31
	RJMP _0x2C8
_0x2C9:
; 0000 02E0                     ledg1 = 1;
	SBI  0x8,4
; 0000 02E1                     ledg2 = 1;
	SBI  0xB,2
; 0000 02E2                     ledg4 = 1;
	RCALL SUBOPT_0x14
; 0000 02E3                     delay_ms(100);
; 0000 02E4                     ledg1 = 0;
	CBI  0x8,4
; 0000 02E5                     ledg2 = 0;
	CBI  0xB,2
; 0000 02E6                     ledg4 = 0;
	CBI  0xB,7
; 0000 02E7                   }
	RCALL SUBOPT_0x1E
	RJMP _0x295
_0x296:
; 0000 02E8                   counter3 = 0;
	CLR  R11
	CLR  R12
; 0000 02E9                   selection = 4;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 5,6
; 0000 02EA                }
; 0000 02EB                //TI CS JMT PETO OPCIJO
; 0000 02EC                if (selection == 5){
_0x291:
	RCALL SUBOPT_0x7
	BREQ PC+2
	RJMP _0x2E2
; 0000 02ED                int done = 1;
; 0000 02EE                int count1 = 0;
; 0000 02EF                int count2 = 0;
; 0000 02F0                int count3 = 0;
; 0000 02F1                int count4 = 0;
; 0000 02F2                int check1 = 0;
; 0000 02F3                int check2 = 0;
; 0000 02F4                int check3 = 0;
; 0000 02F5                int check4 = 0;
; 0000 02F6                int speed1 = 0;
; 0000 02F7 
; 0000 02F8                ledy4 = 0;
	SBIW R28,20
	LDI  R24,20
	__GETWRN 22,23,0
	LDI  R30,LOW(_0x2E3*2)
	LDI  R31,HIGH(_0x2E3*2)
	RCALL __INITLOCB
;	done -> Y+18
;	count1 -> Y+16
;	count2 -> Y+14
;	count3 -> Y+12
;	count4 -> Y+10
;	check1 -> Y+8
;	check2 -> Y+6
;	check3 -> Y+4
;	check4 -> Y+2
;	speed1 -> Y+0
	CBI  0xB,6
; 0000 02F9                delay_ms(250);
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
; 0000 02FA 
; 0000 02FB                   while (done) {
_0x2E6:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	SBIW R30,0
	BRNE PC+2
	RJMP _0x2E8
; 0000 02FC 
; 0000 02FD 
; 0000 02FE                     ledg1 = 1;
	SBI  0x8,4
; 0000 02FF                     if (button1 == 0){
	SBIC 0x6,5
	RJMP _0x2EB
; 0000 0300                         check1--;
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SBIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 0301                     }
; 0000 0302                     delay_ms(100);
_0x2EB:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0303                     if (button1 == 0){
	SBIC 0x6,5
	RJMP _0x2EC
; 0000 0304                         check1++;
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
; 0000 0305                     }
; 0000 0306                     delay_ms(150);
_0x2EC:
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0307                     switch (check1){
	LDD  R30,Y+8
	LDD  R31,Y+8+1
; 0000 0308                            case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2F0
; 0000 0309                                 ledg1 = 1;
	SBI  0x8,4
; 0000 030A                                 ledy1 = 0;
	CBI  0x8,3
; 0000 030B                                 ledr1 = 0;
	CBI  0x8,2
; 0000 030C                            break;
	RJMP _0x2EF
; 0000 030D                            case 2:
_0x2F0:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2F7
; 0000 030E                                 ledy1 = 1;
	SBI  0x8,3
; 0000 030F                                 ledr1 = 0;
	CBI  0x8,2
; 0000 0310                                 ledg1 = 0;
	RJMP _0x4CD
; 0000 0311                            break;
; 0000 0312                            case 3:
_0x2F7:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2EF
; 0000 0313                                 ledr1 = 1;
	SBI  0x8,2
; 0000 0314                                 ledy1 = 0;
	CBI  0x8,3
; 0000 0315                                 ledg1 = 0;
_0x4CD:
	CBI  0x8,4
; 0000 0316                            break;
; 0000 0317                     }
_0x2EF:
; 0000 0318 
; 0000 0319 
; 0000 031A 
; 0000 031B                     ledg1 = 0;
	CBI  0x8,4
; 0000 031C                     ledg2 = 1;
	SBI  0xB,2
; 0000 031D                     if (button2 == 0){
	SBIC 0x6,1
	RJMP _0x309
; 0000 031E                         check2--;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 031F                     }
; 0000 0320                     delay_ms(100);
_0x309:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0321                     if (button2 == 0){
	SBIC 0x6,1
	RJMP _0x30A
; 0000 0322                         check2++;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0000 0323                     }
; 0000 0324                     delay_ms(150);
_0x30A:
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0325                     switch (check2){
	LDD  R30,Y+6
	LDD  R31,Y+6+1
; 0000 0326                            case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x30E
; 0000 0327                                 ledg2 = 1;
	SBI  0xB,2
; 0000 0328                                 ledr2 = 0;
	CBI  0xB,4
; 0000 0329                                 ledy2 = 0;
	CBI  0xB,3
; 0000 032A                            break;
	RJMP _0x30D
; 0000 032B                            case 2:
_0x30E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x315
; 0000 032C                                 ledy2 = 1;
	SBI  0xB,3
; 0000 032D                                 ledg2 = 0;
	CBI  0xB,2
; 0000 032E                                 ledr2 = 0;
	CBI  0xB,4
; 0000 032F                            break;
	RJMP _0x30D
; 0000 0330                            case 3:
_0x315:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x30D
; 0000 0331                                 ledg2 = 0;
	CBI  0xB,2
; 0000 0332                                 ledy2 = 0;
	CBI  0xB,3
; 0000 0333                                 ledr2 = 1;
	SBI  0xB,4
; 0000 0334                            break;
; 0000 0335                     }
_0x30D:
; 0000 0336 
; 0000 0337 
; 0000 0338 
; 0000 0339                     ledg2 = 0;
	CBI  0xB,2
; 0000 033A                     ledg3 = 1;
	SBI  0x5,3
; 0000 033B                     if (button4 == 0){
	SBIC 0x3,4
	RJMP _0x327
; 0000 033C                         check3--;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SBIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 033D                     }
; 0000 033E                     delay_ms(100);
_0x327:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 033F                     if (button4 == 0){
	SBIC 0x3,4
	RJMP _0x328
; 0000 0340                         check3++;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 0341                     }
; 0000 0342                     delay_ms(150);
_0x328:
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0343                     switch (check3){
	LDD  R30,Y+4
	LDD  R31,Y+4+1
; 0000 0344                            case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x32C
; 0000 0345                                 ledg3 = 1;
	SBI  0x5,3
; 0000 0346                                 ledr3 = 0;
	CBI  0x5,1
; 0000 0347                                 ledy3 = 0;
	RJMP _0x4CE
; 0000 0348                            break;
; 0000 0349                            case 2:
_0x32C:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x333
; 0000 034A                                 ledy3 = 1;
	SBI  0x5,2
; 0000 034B                                 ledr3 = 0;
	CBI  0x5,1
; 0000 034C                                 ledg3 = 0;
	CBI  0x5,3
; 0000 034D                            break;
	RJMP _0x32B
; 0000 034E                            case 3:
_0x333:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x32B
; 0000 034F                                 ledr3 = 1;
	SBI  0x5,1
; 0000 0350                                 ledg3 = 0;
	CBI  0x5,3
; 0000 0351                                 ledy3 = 0;
_0x4CE:
	CBI  0x5,2
; 0000 0352                            break;
; 0000 0353                     }
_0x32B:
; 0000 0354 
; 0000 0355 
; 0000 0356 
; 0000 0357                     ledg3 = 0;
	CBI  0x5,3
; 0000 0358                     ledg4 = 1;
	SBI  0xB,7
; 0000 0359                     if (button3 == 0){
	SBIC 0x3,0
	RJMP _0x345
; 0000 035A                         check4--;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 035B                     }
; 0000 035C                     delay_ms(100);
_0x345:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 035D                     if (button3 == 0){
	SBIC 0x3,0
	RJMP _0x346
; 0000 035E                         check4++;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 035F                     }
; 0000 0360                     delay_ms(150);
_0x346:
	LDI  R26,LOW(150)
	LDI  R27,0
	RCALL _delay_ms
; 0000 0361                     switch (check4){
	LDD  R30,Y+2
	LDD  R31,Y+2+1
; 0000 0362                            case 1:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x34A
; 0000 0363                                 ledg4 = 1;
	SBI  0xB,7
; 0000 0364                                 ledr4 = 0;
	CBI  0xB,5
; 0000 0365                                 ledy4 = 0;
	RJMP _0x4CF
; 0000 0366                            break;
; 0000 0367                            case 2:
_0x34A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x351
; 0000 0368                                 ledy4 = 1;
	SBI  0xB,6
; 0000 0369                                 ledr4 = 0;
	CBI  0xB,5
; 0000 036A                                 ledg4 = 0;
	CBI  0xB,7
; 0000 036B                            break;
	RJMP _0x349
; 0000 036C                            case 3:
_0x351:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x349
; 0000 036D                                 ledr4 = 1;
	SBI  0xB,5
; 0000 036E                                 ledg4 = 0;
	CBI  0xB,7
; 0000 036F                                 ledy4 = 0;
_0x4CF:
	CBI  0xB,6
; 0000 0370                            break;
; 0000 0371                     }
_0x349:
; 0000 0372                     ledg4 = 0;
	CBI  0xB,7
; 0000 0373 
; 0000 0374 
; 0000 0375 
; 0000 0376 
; 0000 0377 
; 0000 0378 
; 0000 0379                     if (check1 == 4|check2 == 4|check3 == 4|check4 == 4){
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x23
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x23
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __EQW12
	OR   R30,R0
	BREQ _0x361
; 0000 037A                         ledr1=ledy1=ledg1=ledr2=ledy2=ledg2=ledr3=ledy3=ledg3=ledr4=ledy4=ledg4=0;
	RCALL SUBOPT_0x24
; 0000 037B                         delay_ms(250);
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
; 0000 037C                         if (check1 == 4){
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,4
	BRNE _0x37A
; 0000 037D                            ledr1 = 1;
	RCALL SUBOPT_0x25
; 0000 037E                            ledy1 = 1;
; 0000 037F                            ledg1 = 1;
; 0000 0380                            delay_ms(250);
; 0000 0381                            ledr1 = 0;
; 0000 0382                            ledy1 = 0;
; 0000 0383                            ledg1 = 0;
; 0000 0384                            delay_ms(250);
; 0000 0385                            ledr1 = 1;
	RCALL SUBOPT_0x25
; 0000 0386                            ledy1 = 1;
; 0000 0387                            ledg1 = 1;
; 0000 0388                            delay_ms(250);
; 0000 0389                            ledr1 = 0;
; 0000 038A                            ledy1 = 0;
; 0000 038B                            ledg1 = 0;
; 0000 038C                            delay_ms(250);
; 0000 038D                            ledr1 = 1;
	SBI  0x8,2
; 0000 038E                            ledy1 = 1;
	SBI  0x8,3
; 0000 038F                            ledg1 = 1;
	SBI  0x8,4
; 0000 0390                            delay_ms(250);
	LDI  R26,LOW(250)
	RCALL SUBOPT_0x26
; 0000 0391                            ledr1 = 0;
; 0000 0392                            ledy1 = 0;
; 0000 0393                            ledg1 = 0;
; 0000 0394 
; 0000 0395                         }
; 0000 0396                         if (check2 == 4){
_0x37A:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,4
	BRNE _0x39F
; 0000 0397                            ledr2 = 1;
	RCALL SUBOPT_0x27
; 0000 0398                            ledy2 = 1;
; 0000 0399                            ledg2 = 1;
; 0000 039A                            delay_ms(250);
; 0000 039B                            ledr2 = 0;
; 0000 039C                            ledy2 = 0;
; 0000 039D                            ledg2 = 0;
; 0000 039E                            delay_ms(250);
; 0000 039F                            ledr2 = 1;
	RCALL SUBOPT_0x27
; 0000 03A0                            ledy2 = 1;
; 0000 03A1                            ledg2 = 1;
; 0000 03A2                            delay_ms(250);
; 0000 03A3                            ledr2 = 0;
; 0000 03A4                            ledy2 = 0;
; 0000 03A5                            ledg2 = 0;
; 0000 03A6                            delay_ms(250);
; 0000 03A7                            ledr2 = 1;
	SBI  0xB,4
; 0000 03A8                            ledy2 = 1;
	SBI  0xB,3
; 0000 03A9                            ledg2 = 1;
	SBI  0xB,2
; 0000 03AA                            delay_ms(250);
	LDI  R26,LOW(250)
	RCALL SUBOPT_0x28
; 0000 03AB                            ledr2 = 0;
; 0000 03AC                            ledy2 = 0;
; 0000 03AD                            ledg2 = 0;
; 0000 03AE 
; 0000 03AF                         }
; 0000 03B0                         if (check3 == 4){
_0x39F:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,4
	BRNE _0x3C4
; 0000 03B1                            ledr3 = 1;
	SBI  0x5,1
; 0000 03B2                            ledy3 = 1;
	SBI  0x5,2
; 0000 03B3                            ledg3 = 1;
	RCALL SUBOPT_0x1F
; 0000 03B4                            delay_ms(250);
; 0000 03B5                            ledr3 = 0;
	RCALL SUBOPT_0x29
; 0000 03B6                            ledy3 = 0;
; 0000 03B7                            ledg3 = 0;
; 0000 03B8                            delay_ms(250);
; 0000 03B9                            ledr3 = 1;
; 0000 03BA                            ledy3 = 1;
; 0000 03BB                            ledg3 = 1;
; 0000 03BC                            delay_ms(250);
; 0000 03BD                            ledr3 = 0;
	RCALL SUBOPT_0x29
; 0000 03BE                            ledy3 = 0;
; 0000 03BF                            ledg3 = 0;
; 0000 03C0                            delay_ms(250);
; 0000 03C1                            ledr3 = 1;
; 0000 03C2                            ledy3 = 1;
; 0000 03C3                            ledg3 = 1;
; 0000 03C4                            delay_ms(250);
; 0000 03C5                            ledr3 = 0;
	CBI  0x5,1
; 0000 03C6                            ledy3 = 0;
	CBI  0x5,2
; 0000 03C7                            ledg3 = 0;
	CBI  0x5,3
; 0000 03C8 
; 0000 03C9                         }
; 0000 03CA                         if (check4 == 4){
_0x3C4:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,4
	BRNE _0x3E9
; 0000 03CB                            ledr4 = 1;
	RCALL SUBOPT_0x2A
; 0000 03CC                            ledy4 = 1;
; 0000 03CD                            ledg4 = 1;
; 0000 03CE                            delay_ms(250);
; 0000 03CF                            ledr4 = 0;
; 0000 03D0                            ledy4 = 0;
; 0000 03D1                            ledg4 = 0;
; 0000 03D2                            delay_ms(250);
; 0000 03D3                            ledr4 = 1;
	RCALL SUBOPT_0x2A
; 0000 03D4                            ledy4 = 1;
; 0000 03D5                            ledg4 = 1;
; 0000 03D6                            delay_ms(250);
; 0000 03D7                            ledr4 = 0;
; 0000 03D8                            ledy4 = 0;
; 0000 03D9                            ledg4 = 0;
; 0000 03DA                            delay_ms(250);
; 0000 03DB                            ledr4 = 1;
	SBI  0xB,5
; 0000 03DC                            ledy4 = 1;
	SBI  0xB,6
; 0000 03DD                            ledg4 = 1;
	SBI  0xB,7
; 0000 03DE                            delay_ms(250);
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
; 0000 03DF                            ledr4 = 0;
	CBI  0xB,5
; 0000 03E0                            ledy4 = 0;
	CBI  0xB,6
; 0000 03E1                            ledg4 = 0;
	CBI  0xB,7
; 0000 03E2                         }
; 0000 03E3                         check1=check2=check3=check4=0;
_0x3E9:
	RCALL SUBOPT_0x2B
; 0000 03E4                         done = 0;
	LDI  R30,LOW(0)
	STD  Y+18,R30
	STD  Y+18+1,R30
; 0000 03E5                     }
; 0000 03E6                     if (check1 == -2|check2 == -2|check3 == -2|check4 == -2){
_0x361:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x2C
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL SUBOPT_0x2C
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RCALL __EQW12
	OR   R30,R0
	BREQ _0x40E
; 0000 03E7                         if (check1 == -2){
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0xFFFE)
	LDI  R30,HIGH(0xFFFE)
	CPC  R27,R30
	BRNE _0x40F
; 0000 03E8                            ledr1 = 1;
	SBI  0x8,2
; 0000 03E9                            ledy1 = 1;
	SBI  0x8,3
; 0000 03EA                            ledg1 = 1;
	SBI  0x8,4
; 0000 03EB                            delay_ms(100);
	LDI  R26,LOW(100)
	RCALL SUBOPT_0x26
; 0000 03EC                            ledr1 = 0;
; 0000 03ED                            ledy1 = 0;
; 0000 03EE                            ledg1 = 0;
; 0000 03EF                            delay_ms(100);
	RCALL SUBOPT_0x20
; 0000 03F0                            ledr1 = 1;
; 0000 03F1                            ledy1 = 1;
	SBI  0x8,3
; 0000 03F2                            ledg1 = 1;
	SBI  0x8,4
; 0000 03F3                            delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 03F4                            ledr1 = 0;
	CBI  0x8,2
; 0000 03F5                            ledy1 = 0;
	CBI  0x8,3
; 0000 03F6                         }
; 0000 03F7                         if (check2 == -2){
_0x40F:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CPI  R26,LOW(0xFFFE)
	LDI  R30,HIGH(0xFFFE)
	CPC  R27,R30
	BRNE _0x426
; 0000 03F8                            ledr2 = 1;
	RCALL SUBOPT_0x2D
; 0000 03F9                            ledy2 = 1;
; 0000 03FA                            ledg2 = 1;
; 0000 03FB                            delay_ms(100);
; 0000 03FC                            ledr2 = 0;
; 0000 03FD                            ledy2 = 0;
; 0000 03FE                            ledg2 = 0;
; 0000 03FF                            delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 0400                            ledr2 = 1;
; 0000 0401                            ledy2 = 1;
; 0000 0402                            ledg2 = 1;
; 0000 0403                            delay_ms(100);
; 0000 0404                            ledr2 = 0;
; 0000 0405                            ledy2 = 0;
; 0000 0406                            ledg2 = 0;
; 0000 0407                            delay_ms(100);
	RCALL SUBOPT_0x2E
; 0000 0408                            ledr2 = 1;
; 0000 0409                            ledy2 = 1;
; 0000 040A                            ledg2 = 1;
; 0000 040B                            delay_ms(100);
; 0000 040C                            ledr2 = 0;
; 0000 040D                            ledy2 = 0;
; 0000 040E                            ledg2 = 0;
; 0000 040F 
; 0000 0410                         }
; 0000 0411                         if (check3 == -2){
_0x426:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CPI  R26,LOW(0xFFFE)
	LDI  R30,HIGH(0xFFFE)
	CPC  R27,R30
	BRNE _0x44B
; 0000 0412                            ledr3 = 1;
	SBI  0x5,1
; 0000 0413                            ledy3 = 1;
	SBI  0x5,2
; 0000 0414                            ledg3 = 1;
	RCALL SUBOPT_0x18
; 0000 0415                            delay_ms(100);
; 0000 0416                            ledr3 = 0;
	RCALL SUBOPT_0x2F
; 0000 0417                            ledy3 = 0;
; 0000 0418                            ledg3 = 0;
; 0000 0419                            delay_ms(100);
; 0000 041A                            ledr3 = 1;
; 0000 041B                            ledy3 = 1;
; 0000 041C                            ledg3 = 1;
; 0000 041D                            delay_ms(100);
; 0000 041E                            ledr3 = 0;
	RCALL SUBOPT_0x2F
; 0000 041F                            ledy3 = 0;
; 0000 0420                            ledg3 = 0;
; 0000 0421                            delay_ms(100);
; 0000 0422                            ledr3 = 1;
; 0000 0423                            ledy3 = 1;
; 0000 0424                            ledg3 = 1;
; 0000 0425                            delay_ms(100);
; 0000 0426                            ledr3 = 0;
	CBI  0x5,1
; 0000 0427                            ledy3 = 0;
	CBI  0x5,2
; 0000 0428                            ledg3 = 0;
	CBI  0x5,3
; 0000 0429 
; 0000 042A                         }
; 0000 042B                         if (check4 == -2){
_0x44B:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CPI  R26,LOW(0xFFFE)
	LDI  R30,HIGH(0xFFFE)
	CPC  R27,R30
	BRNE _0x470
; 0000 042C                            ledr4 = 1;
	SBI  0xB,5
; 0000 042D                            ledy4 = 1;
	SBI  0xB,6
; 0000 042E                            ledg4 = 1;
	RCALL SUBOPT_0x14
; 0000 042F                            delay_ms(100);
; 0000 0430                            ledr4 = 0;
	RCALL SUBOPT_0x30
; 0000 0431                            ledy4 = 0;
; 0000 0432                            ledg4 = 0;
; 0000 0433                            delay_ms(100);
; 0000 0434                            ledr4 = 1;
; 0000 0435                            ledy4 = 1;
; 0000 0436                            ledg4 = 1;
; 0000 0437                            delay_ms(100);
; 0000 0438                            ledr4 = 0;
	RCALL SUBOPT_0x30
; 0000 0439                            ledy4 = 0;
; 0000 043A                            ledg4 = 0;
; 0000 043B                            delay_ms(100);
; 0000 043C                            ledr4 = 1;
; 0000 043D                            ledy4 = 1;
; 0000 043E                            ledg4 = 1;
; 0000 043F                            delay_ms(100);
; 0000 0440                            ledr4 = 0;
	CBI  0xB,5
; 0000 0441                            ledy4 = 0;
	CBI  0xB,6
; 0000 0442                            ledg4 = 0;
	CBI  0xB,7
; 0000 0443                         }
; 0000 0444                         check1=check2=check3=check4=0;
_0x470:
	RCALL SUBOPT_0x2B
; 0000 0445 
; 0000 0446                         ledr1=ledy1=ledg1=ledr2=ledy2=ledg2=ledr3=ledy3=ledg3=ledr4=ledy4=ledg4=0;
	RCALL SUBOPT_0x24
; 0000 0447 
; 0000 0448                         done = 0;
	LDI  R30,LOW(0)
	STD  Y+18,R30
	STD  Y+18+1,R30
; 0000 0449                     }
; 0000 044A                     if(button5 == 0){
_0x40E:
	SBIC 0x6,0
	RJMP _0x4AD
; 0000 044B                         done = 0;
	LDI  R30,LOW(0)
	STD  Y+18,R30
	STD  Y+18+1,R30
; 0000 044C                         delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 044D                         ledr1=ledy1=ledg1=ledr2=ledy2=ledg2=ledr3=ledy3=ledg3=ledr4=ledy4=ledg4=0;
	RCALL SUBOPT_0x24
; 0000 044E                     }
; 0000 044F                   }
_0x4AD:
	RJMP _0x2E6
_0x2E8:
; 0000 0450 
; 0000 0451                   counter5 = 0;
	LDI  R30,LOW(0)
	STS  _counter5,R30
	STS  _counter5+1,R30
; 0000 0452                   selection = 5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1R 5,6
; 0000 0453                }
	ADIW R28,20
; 0000 0454                //TI CS JMT SESTO OPCIJO
; 0000 0455                if (selection == 6){
_0x2E2:
	RCALL SUBOPT_0x8
	BRNE _0x4C6
; 0000 0456                ledr4 = 0;
	CBI  0xB,5
; 0000 0457                   for (counter6=0; counter6 < 10;counter6++) {
	RCALL SUBOPT_0x31
_0x4CA:
	LDS  R26,_counter6
	LDS  R27,_counter6+1
	SBIW R26,10
	BRGE _0x4CB
; 0000 0458 
; 0000 0459                   }
	LDI  R26,LOW(_counter6)
	LDI  R27,HIGH(_counter6)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0x4CA
_0x4CB:
; 0000 045A                   counter6 = 0;
	RCALL SUBOPT_0x31
; 0000 045B                   selection = 6;
	RCALL SUBOPT_0xA
; 0000 045C                }
; 0000 045D                //KWANC OPCIJ
; 0000 045E           confirm = 0;
_0x4C6:
	CLR  R3
	CLR  R4
; 0000 045F           //ZDEJ PA SI KEJ DRUZGA ZBERI
; 0000 0460           }
; 0000 0461       }
_0x59:
	RJMP _0x3
; 0000 0462 }
_0x4CC:
	RJMP _0x4CC
; .FEND

	.DSEG
_counter5:
	.BYTE 0x2
_counter6:
	.BYTE 0x2
_pass1:
	.BYTE 0x2
_pass2:
	.BYTE 0x2
_pass3:
	.BYTE 0x2
_section2done:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	STS  133,R30
	LDI  R30,LOW(0)
	STS  132,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	CBI  0xB,5
	CBI  0xB,6
	CBI  0xB,7
	CBI  0xB,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	CBI  0xB,7
	CBI  0xB,3
	CBI  0xB,2
	CBI  0xB,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CP   R30,R5
	CPC  R31,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 5,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	__PUTW1R 5,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB:
	SBI  0x8,4
	SBI  0xB,2
	SBI  0x5,3
	SBI  0xB,7
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,4
	CBI  0xB,2
	CBI  0x5,3
	CBI  0xB,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xC:
	SBI  0x8,3
	SBI  0xB,3
	SBI  0x5,2
	SBI  0xB,6
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,3
	CBI  0xB,3
	CBI  0x5,2
	CBI  0xB,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xD:
	SBI  0x8,2
	SBI  0xB,4
	SBI  0x5,1
	SBI  0xB,5
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,2
	CBI  0xB,4
	CBI  0x5,1
	CBI  0xB,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0xE:
	SBI  0x8,4
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,4
	SBI  0x8,3
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,3
	SBI  0x8,2
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0xF:
	SBI  0xB,2
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,2
	SBI  0xB,3
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,3
	SBI  0xB,4
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x10:
	SBI  0x5,3
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x5,3
	SBI  0x5,2
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x5,2
	SBI  0x5,1
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x5,1
	SBI  0xB,7
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,7
	SBI  0xB,6
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,6
	SBI  0xB,5
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,2
	CBI  0x8,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	SBI  0x5,1
	LDI  R26,LOW(50)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	SBI  0x5,3
	LDI  R26,LOW(50)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x14:
	SBI  0xB,7
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,4
	CBI  0xB,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x16:
	SBI  0xB,5
	LDI  R26,LOW(50)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x17:
	SBI  0xB,7
	LDI  R26,LOW(50)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x18:
	SBI  0x5,3
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x5,2
	SBI  0x5,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1A:
	SBI  0x8,3
	SBI  0xB,3
	SBI  0x5,2
	SBI  0xB,6
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
	CBI  0x8,3
	CBI  0xB,3
	CBI  0x5,2
	CBI  0xB,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x1B:
	SBI  0x8,2
	SBI  0xB,4
	SBI  0x5,1
	SBI  0xB,5
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
	CBI  0x8,2
	CBI  0xB,4
	CBI  0x5,1
	CBI  0xB,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x1C:
	SBI  0x8,2
	SBI  0xB,4
	SBI  0x5,1
	SBI  0xB,5
	LDI  R30,LOW(0)
	STS  _pass1,R30
	STS  _pass1+1,R30
	STS  _pass2,R30
	STS  _pass2+1,R30
	STS  _pass3,R30
	STS  _pass3+1,R30
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
	CBI  0x8,2
	CBI  0xB,4
	CBI  0x5,1
	CBI  0xB,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDI  R26,LOW(50)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 11,12,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1F:
	SBI  0x5,3
	LDI  R26,LOW(250)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	SBI  0x8,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	CBI  0x8,4
	CBI  0xB,2
	CBI  0xB,7
	LDI  R26,LOW(50)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	RCALL __EQW12
	MOV  R0,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __EQW12
	OR   R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x24:
	CBI  0xB,7
	CBI  0xB,6
	CBI  0xB,5
	CBI  0x5,3
	CBI  0x5,2
	CBI  0x5,1
	CBI  0xB,2
	CBI  0xB,3
	CBI  0xB,4
	CBI  0x8,4
	CBI  0x8,3
	CBI  0x8,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x25:
	SBI  0x8,2
	SBI  0x8,3
	SBI  0x8,4
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,2
	CBI  0x8,3
	CBI  0x8,4
	LDI  R26,LOW(250)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	LDI  R27,0
	RCALL _delay_ms
	CBI  0x8,2
	CBI  0x8,3
	CBI  0x8,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x27:
	SBI  0xB,4
	SBI  0xB,3
	SBI  0xB,2
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,4
	CBI  0xB,3
	CBI  0xB,2
	LDI  R26,LOW(250)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x28:
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,4
	CBI  0xB,3
	CBI  0xB,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x29:
	CBI  0x5,1
	CBI  0x5,2
	CBI  0x5,3
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
	SBI  0x5,1
	SBI  0x5,2
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2A:
	SBI  0xB,5
	SBI  0xB,6
	SBI  0xB,7
	LDI  R26,LOW(250)
	LDI  R27,0
	RCALL _delay_ms
	CBI  0xB,5
	CBI  0xB,6
	CBI  0xB,7
	LDI  R26,LOW(250)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STD  Y+2,R30
	STD  Y+2+1,R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	STD  Y+6,R30
	STD  Y+6+1,R31
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RCALL __EQW12
	OR   R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2D:
	SBI  0xB,4
	SBI  0xB,3
	SBI  0xB,2
	LDI  R26,LOW(100)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2E:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2F:
	CBI  0x5,1
	CBI  0x5,2
	CBI  0x5,3
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	SBI  0x5,1
	SBI  0x5,2
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x30:
	CBI  0xB,5
	CBI  0xB,6
	CBI  0xB,7
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	SBI  0xB,5
	SBI  0xB,6
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x31:
	LDI  R30,LOW(0)
	STS  _counter6,R30
	STS  _counter6+1,R30
	RET

;RUNTIME LIBRARY

	.CSEG
__INITLOCB:
__INITLOCW:
	PUSH R26
	PUSH R27
	MOVW R26,R22
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	POP  R27
	POP  R26
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	wdr
	__DELAY_USW 0xFA0
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

;END OF CODE MARKER
__END_OF_CODE:
